Makefile.am 9.97 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
Michael Hanselmann's avatar
Michael Hanselmann committed
14
BUILD_RAPI_RESOURCE_DOC = $(top_srcdir)/doc/build-rapi-resources-doc
15 16 17
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
18
httpdir = $(pkgpythondir)/http
19
rapidir = $(pkgpythondir)/rapi
20 21 22 23 24 25 26 27 28
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
Guido Trotter's avatar
Guido Trotter committed
29
	doc/examples/hooks \
30
	lib \
31
	lib/http \
32
	lib/hypervisor \
33
	lib/rapi \
34 35 36 37 38 39 40
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
41 42 43 44 45
MAINTAINERCLEANFILES = \
	$(dochtml) \
	$(patsubst %.dot,%.png,$(docdot)) \
	$(maninput)

46 47
CLEANFILES = \
	autotools/replace_vars.sed \
48
	daemons/ganeti-cleaner \
49
	devel/upload \
50
	doc/rapi-resources.gen \
51
	doc/examples/bash_completion \
52 53 54
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
55
	lib/http/*.py[co] \
56
	lib/hypervisor/*.py[co] \
57
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
58 59
	$(man_MANS) \
	$(manhtml) \
60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
77
	lib/daemon.py \
78 79
	lib/errors.py \
	lib/jqueue.py \
80
	lib/jstore.py \
81 82 83 84 85 86 87 88 89
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
90 91
	lib/utils.py \
	lib/workerpool.py
92 93 94 95 96

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
97
	lib/hypervisor/hv_kvm.py \
98 99
	lib/hypervisor/hv_xen.py

100 101
rapi_PYTHON = \
	lib/rapi/__init__.py \
102 103 104
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
105

106
http_PYTHON = \
107
	lib/http/__init__.py \
108
	lib/http/auth.py \
109 110
	lib/http/client.py \
	lib/http/server.py
111

112

Michael Hanselmann's avatar
Michael Hanselmann committed
113
docrst = \
114
	doc/admin.rst \
115
	doc/design-2.0.rst \
116
	doc/hooks.rst \
117
	doc/iallocator.rst \
118
	doc/install.rst \
119
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
120

Iustin Pop's avatar
Iustin Pop committed
121 122
dochtml = $(patsubst %.rst,%.html,$(docrst))

123 124 125
docdot = \
	doc/arch-2.0.dot

Iustin Pop's avatar
Iustin Pop committed
126
doc_DATA = $(dochtml)
127

128 129
noinst_DATA = $(manhtml)

130 131 132 133
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
134
	daemons/ganeti-rapi \
135 136 137 138 139 140 141 142
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

143 144 145
nodist_sbin_SCRIPTS = \
	daemons/ganeti-cleaner

146 147 148 149 150 151 152
dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
153
	$(MAINTAINERCLEANFILES) \
154 155
	NEWS \
	DEVNOTES \
Michael Hanselmann's avatar
Michael Hanselmann committed
156
	pylintrc \
157
	autotools/docbook-wrapper \
158
	daemons/ganeti-cleaner.in \
159
	devel/upload.in \
Michael Hanselmann's avatar
Michael Hanselmann committed
160
	$(docrst) \
161
	$(docdot) \
162
	doc/build-rapi-resources-doc \
163
	doc/examples/bash_completion.in \
164 165 166
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
Guido Trotter's avatar
Guido Trotter committed
167
	doc/examples/hooks/ethers \
168
	doc/locking.txt \
169 170 171 172 173
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
174
	$(mansgml) $(maninput) \
175
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
176
	qa/qa-sample.json \
177 178 179 180 181 182 183 184
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
185
	qa/qa_rapi.py \
186 187 188 189 190
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
191
	man/ganeti-masterd.8 \
192 193
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
194
	man/ganeti-rapi.8 \
195 196 197
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
198
	man/gnt-debug.8 \
199
	man/gnt-instance.8 \
200
	man/gnt-job.8 \
201 202 203
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
204 205 206
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
207 208 209

TEST_FILES = \
	test/data/bdev-both.txt \
210
	test/data/bdev-8.3-both.txt \
211 212
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
213
	test/data/proc_drbd8.txt \
214
	test/data/proc_drbd80-emptyline.txt \
215
	test/data/proc_drbd83.txt
216 217

dist_TESTS = \
218 219 220
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
221
	test/ganeti.config_unittest.py \
222
	test/ganeti.constants_unittest.py \
223
	test/ganeti.hooks_unittest.py \
224
	test/ganeti.http_unittest.py \
225
	test/ganeti.locking_unittest.py \
226
	test/ganeti.rapi.resources_unittest.py \
227 228 229 230
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
231 232 233 234 235

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

236
TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir) $(PYTHON)
237

238
RAPI_RESOURCES = $(wildcard lib/rapi/*.py)
239

240
all-local: stamp-directories lib/_autoconf.py devel/upload \
Iustin Pop's avatar
Iustin Pop committed
241
	doc/examples/bash_completion \
242 243 244 245 246 247
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
248
doc/examples/%: doc/examples/%.in stamp-directories \
249 250 251
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

252 253 254 255 256
daemons/ganeti-cleaner: daemons/ganeti-cleaner.in stamp-directories \
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod +x $@

Michael Hanselmann's avatar
Michael Hanselmann committed
257
doc/%.html: doc/%.rst
Iustin Pop's avatar
Iustin Pop committed
258
	@test -n "$(RST2HTML)" || { echo 'rst2html' not found during configure; exit 1; }
Michael Hanselmann's avatar
Michael Hanselmann committed
259 260
	$(RST2HTML) $< $@

261
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
262
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
263 264 265 266
	$(DOT) -Tpng -o $@ $<

doc/design-2.0.html: doc/design-2.0.rst doc/arch-2.0.png

Iustin Pop's avatar
Iustin Pop committed
267
doc/rapi.html: doc/rapi-resources.gen
268

269 270 271
doc/rapi-resources.gen: $(BUILD_RAPI_RESOURCE_DOC) $(RAPI_RESOURCES)
	PYTHONPATH=.:$(top_builddir) $(BUILD_RAPI_RESOURCE_DOC) > $@ || \
	  rm -f $@
272

Iustin Pop's avatar
Iustin Pop committed
273
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
274
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
275 276 277 278 279 280 281
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
282
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
283 284 285 286 287 288 289 290
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
291

Iustin Pop's avatar
Iustin Pop committed
292 293
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
294

Iustin Pop's avatar
Iustin Pop committed
295 296
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
297

298 299
man/footer.sgml $(TESTS): srclinks

Michael Hanselmann's avatar
Michael Hanselmann committed
300
$(TESTS) $(BUILD_RAPI_RESOURCE_DOC): ganeti lib/_autoconf.py
301 302 303 304 305

lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
306 307 308 309 310 311 312 313 314
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
315 316 317 318 319 320 321 322 323 324 325 326 327 328 329
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
330
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
331
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
332
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
333
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)" ; \
334 335 336 337 338 339 340 341 342 343 344
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
345
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
Iustin Pop's avatar
Iustin Pop committed
346
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
347 348 349 350 351 352 353
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
#.PHONY: srclinks
srclinks: stamp-directories
	set -e; \
354 355
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
			$(rapi_PYTHON) $(http_PYTHON); do \
356 357 358 359
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
360

Michael Hanselmann's avatar
Michael Hanselmann committed
361 362
.PHONY: ganeti
ganeti:
363
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
364

Iustin Pop's avatar
Iustin Pop committed
365 366 367 368 369 370 371
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
372
install-exec-local:
373
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
374 375
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
376 377 378 379 380

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
381 382 383
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
384
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
385 386
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
387
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
388 389
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
390
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
391 392 393 394
		) ; \
		rm -rf $$TMPDIR ; \
	}

395
# vim: set noet :